
#include "Crc16.h"

Crc16 crc;
uint8_t RxBuf[40], RD8_out[8] = {0, 0, 0, 0, 0, 0, 0, 0};
#define MONOSTABIL 0
#define BISTABIL 1
#define TIME 2
uint8_t outMode[8] = {MONOSTABIL, TIME, BISTABIL, BISTABIL, MONOSTABIL, MONOSTABIL, BISTABIL, BISTABIL};
uint32_t HBTimer = 0; //
void setup() {
  Serial.begin (115200);
  pinMode(2, OUTPUT);
  digitalWrite(2, HIGH);

  //input buttons
  pinMode(3, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);
  pinMode(5, INPUT_PULLUP);
  pinMode(6, INPUT_PULLUP);
  pinMode(7, INPUT_PULLUP);
  pinMode(8, INPUT_PULLUP);
  pinMode(9, INPUT_PULLUP);
  pinMode(10, INPUT_PULLUP);

  //output leds
  pinMode(A0, OUTPUT);
  pinMode(A1, OUTPUT);
  pinMode(A2, OUTPUT);
  pinMode(A3, OUTPUT);
  pinMode(A4, OUTPUT);
  pinMode(A5, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(12, OUTPUT);
  HBTimer=millis()-5000;
}

void loop() {
  static uint8_t IOstateOld = 0;
  uint8_t IOstate = readInput();
  delay(10);
  uint8_t IOstate1 = readInput();
  if (millis() - HBTimer > 5000)
  {
    readState();
    HBTimer=millis();
  }
  if (IOstate != IOstateOld )
  {
   
    uint8_t dif = IOstateOld ^ IOstate;
    RD8_send(dif, IOstate);
    IOstateOld = IOstate;
  }

  modbus_rec();
}
void RD8_send(uint8_t dif, uint8_t iIOstate)
{
  unsigned char b[20] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  b[0] = 0; //slave adres
  b[1] = 4; ///writing n registers
  b[2] = 7; // n
  b[3] = 1; //device type. 1 - RD8
  b[4] = 0; //Relays
  b[5] = 0; //Chanel for timing mode


  for (int t = 0; t < 8; t++)
  {
    if (outMode[t] == MONOSTABIL)
    {
      if (iIOstate & (1 << t)) //
        b[4] += (1 << t);
    }
    else if (outMode[t] == BISTABIL)
    {
      if (dif & (1 << t))
      {
        if (iIOstate & (1 << t)) //bistabil mode
        {
          if (LedCheck(t))
            b[4] += (1 << t);
        }
        else
          dif &= ~(1 << t);
      }
      else
      {
        if (!LedCheck(t))
          b[4] += (1 << t);
      }
    }
    else if (outMode[t] == TIME)
    {
      if (dif & (1 << t) && (iIOstate & (1 << t))) //Time mode
      {
        b[4] += (1 << t);
        b[5] = 1;
        uint32_t testTime = 5; //Time = 5sek
        char *y = (char*)&testTime; // Time for timing mode. Reserved fo others.
        b[6] = y[0];
        b[7] = y[1];
        b[8] = y[2];
        b[9] = y[3];
      }
      else
      {
        if (!LedCheck(t))
          b[4] += (1 << t);
      }
    }
  }

  if (dif)
  {
    uint16_t csum = crc.Modbus(b, 0, 10);
    char *y = (unsigned char*)&csum;
    b[10] = y[0];
    b[11] = y[1];
    digitalWrite(2, HIGH); //direction
    for (int t = 0; t < 12; t++)
      Serial.write(b[t]);
    Serial.flush();
    digitalWrite(2, LOW);
  }

}
void modbus_rec()
{
  int slave_adr = 0;
  static uint32_t TimeOutTimer = millis(), RecTimer;
  if (Serial.available())
    TimeOutTimer = millis();
  uint8_t SensorPtr = 0;
  char ramka = 0;
  while ((millis() - TimeOutTimer) < 4)
  {
    if (Serial.available())
    {

      unsigned char c = Serial.read();
      TimeOutTimer = millis();
      if (SensorPtr < 40)
        RxBuf[SensorPtr++] = c;
    }
  }
  if (SensorPtr > 3)
  {
    HBTimer=millis();  
    uint16_t RecCsum;
    char * y = (char*)&RecCsum;
    y[0] = RxBuf[SensorPtr - 2];
    y[1] = RxBuf[SensorPtr - 1];
    uint16_t csum = crc.Modbus(RxBuf, 0, SensorPtr - 2);
    unsigned char data = RxBuf[4];

    //slave_adr=1;
    if (RxBuf[3] == 1 && RecCsum == csum)
    {
      if (RxBuf[1] == 33)
      {
        if (bit_is_set(data, 7))
          digitalWrite(12, LOW);
        else
          digitalWrite(12, HIGH);

        if (bit_is_set(data, 6))
          digitalWrite(11, LOW);
        else
          digitalWrite(11, HIGH);

        if (bit_is_set(data, 5))
          digitalWrite(A0, LOW);
        else
          digitalWrite(A0, HIGH);

        if (bit_is_set(data, 4))
          digitalWrite(A1, LOW);
        else
          digitalWrite(A1, HIGH);

        if (bit_is_set(data, 3))
          digitalWrite(A2, LOW);
        else
          digitalWrite(A2, HIGH);

        if (bit_is_set(data, 2))
          digitalWrite(A3, LOW);
        else
          digitalWrite(A3, HIGH);

        if (bit_is_set(data, 1))
          digitalWrite(A4, LOW);
        else
          digitalWrite(A4, HIGH);
        if (bit_is_set(data, 0))
          digitalWrite(A5, LOW);
        else
          digitalWrite(A5, HIGH);
      }
    }
  }
}
uint8_t LedCheck(uint8_t Out)
{
  switch (Out)
  {
    case 0:
      if (digitalRead(A5))
        return 1;
      break;
    case 1:
      if (digitalRead(A4))
        return 1;
      break;
    case 2:
      if (digitalRead(A3))
        return 1;
      break;
    case 3:
      if (digitalRead(A2))
        return 1;
      break;
    case 4:
      if (digitalRead(A1))
        return 1;
      break;
    case 5:
      if (digitalRead(A0))
        return 1;
      break;
    case 6:
      if (digitalRead(11))
        return 1;
      break;
    case 7:
      if (digitalRead(12))
        return 1;
      break;
  }
  return 0;

}
uint8_t readInput(void)
{
  uint8_t inp = 0;
  if (digitalRead(3) == LOW)
    inp += 1;
  if (digitalRead(4) == LOW)
    inp += 2;
  if (digitalRead(5) == LOW)
    inp += 4;
  if (digitalRead(6) == LOW)
    inp += 8;
  if (digitalRead(7) == LOW)
    inp += 16;
  if (digitalRead(8) == LOW)
    inp += 32;
  if (digitalRead(9) == LOW)
    inp += 64;
  if (digitalRead(10) == LOW)
    inp += 128;
  return inp;
}
void readState(void)
{
  unsigned char b[20] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  b[0] = 0; //slave adres
  b[1] = 3; ///writing n registers
  b[2] = 7; // n
  b[3] = 1; //device type. 1 - RD8
  uint16_t csum = crc.Modbus(b, 0, 10);
  char *y = (unsigned char*)&csum;
  b[10] = y[0];
  b[11] = y[1];
  digitalWrite(2, HIGH); //direction
  for (int t = 0; t < 12; t++)
    Serial.write(b[t]);
  Serial.flush();
  digitalWrite(2, LOW);
}
